#+TITLE: Emacs And Montessori Philosophy
#+AUTHOR: Grant Shangreaux
#+EMAIL: grant@churls.world

* Who am I?

                   [[file:me.png]]     

* Respect

  Emacs and Montessori Philosophy
  are both fundamentally about respect.

  Respect children. Child is parent to the Adult.

  Respect users. User is parent to the Hacker?

* The Prepared Environment

  Everything in the environment
  is there to be explored and manipulated.

#+name: count-of-elisp-source-files
#+begin_src elisp :var dir="~/.guix-profile/share/emacs/27.2/lisp/"
  (length
   (cl-remove-if
    (lambda (f) (string-equal "elc" (file-name-extension f)))
    (directory-files dir)))
#+end_src

#+RESULTS: count-of-elisp-source-files
: 303

  
* Human Tendencies
Innate drives present in everyone.
They compel us to explore and make sense of the world.

** Orientation.

Where am I? Where do I belong?

#+begin_src emacs-lisp
  (switch-to-buffer "*GNU Emacs*")
  (info "Emacs")
  (which-key-show-top-level)
#+end_src

** Order.

People prefer order to chaos and confusion.
Order brings predictability and security.
There are two kinds of order: external and internal.

 #+begin_src emacs-lisp
   (defvar my-org-keymap (make-sparse-keymap))
   (define-prefix-command 'my-org-keymap)
   (define-key my-org-keymap (kbd "s") 'org-insert-structure-template)
   (define-key my-org-keymap (kbd "'") 'org-edit-special)
   ...
 #+end_src

** Exploration.

Our earth is filled with wonderful sounds, scents, textures,
tastes, and colors. Hackers are naturally curious, and love
to use their senses to learn more about the fascinating
world around them.

#+begin_src emacs-lisp
  (switch-to-buffer "*scratch*")
  (ielm)
  (dired)
  (package-list-packages)
#+end_src

** Communication.

Communication is the link of understanding between people,
both face-to-face and from generation to generation.

Elisp from the 1980's 

#+begin_src emacs-lisp
  (erc)
  (mail)
  (gnus)
#+end_src

These slides are in an org-mode buffer

** Activity.

Hacking around with Emacs is easy, fun, and enjoyable.

(my-random-theme)

(butterfly)

(tetris)


** Manipulation.

#+begin_quote
  Humans need to take hold of their environment to understand it.
  It is the next step after exploration: once you have found
  something interesting, you will quite naturally want to use
  it in some way. This is how the concept of "tools" began.
#+end_quote

Lisp anyone?

(set-cursor-color "orange")

(insert "foo")foo

** Work (or Purposeful Activity). 

this is the mailing list for emacs multimedia system

Emms       Yuchen Pei             Recovering playback state of multiple playlists and over multiple sessions
Emms       Yoni Rabkin            LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yuchen Pei              LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yoni Rabkin              LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yuchen Pei                o Re: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yoni Rabkin               |LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yuchen Pei                | LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yoni Rabkin               |  LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yuchen Pei                |   LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yoni Rabkin               |    LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yuchen Pei                |     LRe: Recovering playback state of multiple playlists and over multiple sessions
Emms       Yoni Rabkin               |      LRe: Recovering playback state of multiple playlists and over multiple sessions

** Repetition.

all of my various emacs installs :P

 .emacs -> /home/shoshin/src/chemacs/.emacs
 .emacs.d
 .emacs-profile
 .emacs-profiles.el
 .emacs-profiles.el~
 .evil-spacemacs
 evil-spacemacs/
 new-emacs/
 spacemacs/
 spacemacs-bk -> dotfiles/thinkpad-dotspacemacs.el
 .spacemacs.env
 vanilla-emacs

** Exactness.

#+begin_src emacs-lisp
  (mapc 'straight-use-package (append my-packages my-themes))
  
  (pretty-magit "Feature" ? (:foreground "slate gray" :height 1.2))
  (pretty-magit "Add"     ? (:foreground "#375E97" :height 1.2))
  (pretty-magit "Fix"     ? (:foreground "#FB6542" :height 1.2))
  (pretty-magit "Clean"   ? (:foreground "#FFBB00" :height 1.2))
  (pretty-magit "Docs"    ? (:foreground "#3F681C" :height 1.2))
  (pretty-magit "main"    ? (:foreground "LightSeaGreen" :box t :height 1.2) t)
  (pretty-magit "origin"  ? (:foreground "LightSeaGreen" :box t :height 1.2) t)
#+end_src

** Abstraction.

the buffer is text, text is code,
we can evaluate a whole buffer or
only a single block of code.

 #+begin_src emacs-lisp
   (current-buffer)
 #+end_src

 #+RESULTS:
 : #<buffer emacs-and-montessori.org>

 #+begin_src emacs-lisp
   (+ 2 2)
 #+end_src

** Perfection.

#+begin_quote
  All of the tendencies culminate in this one.
  Once we have explored, manipulated, and worked
  in our environment, we can perfect our activities.
  In doing so, we are drivers of our own minds and bodies
  as well as the tasks we set out to do.
#+end_quote

 
